- name: Redundant-Interface-ACI Playbook
  hosts: all
  connection: local
  gather_facts: no
  vars: 
    host_var: "{{ ansible_host }}"
    apic_login: &apic_login
      host: "{{ host_var }}" 
      username: "{{ user_var }}"
      password: "{{ pass_var }}"
      validate_certs: no
      use_proxy: False   
      use_ssl: True  
      state: absent
    delay_var: 0.1

  tasks:
  - name: Read the paramaters from csv file 
    read_csv:
      path: interface_vpc.csv
    register: interface
    
  - name: Disassociate an Interface Access Port Selector to an Interface Policy Leaf Profile with a Policy Group
    aci_access_port_to_interface_policy_leaf_profile:
      <<: *apic_login
      leaf_interface_profile: "vpc.{{ int.dc }}-{{ int.env }}-L{{ int.leaf1_id }}.L{{ int.leaf2_id }}-intprof"
      access_port_selector: vpc.L{{ int.leaf1_id }}.L{{ int.leaf2_id }}.1.{{ int.interface_id }}-intsel
      interface_type: vpc
      leaf_port_blk: "vpc.L{{ int.leaf1_id }}.L{{ int.leaf2_id }}.1.{{ int.interface_id }}-intblk"
      leaf_port_blk_description: "{{ int.interface_desc }}"
      from_port: "{{ int.interface_id }}"
      to_port: "{{ int.interface_id }}"
      policy_group: "vpc.L{{ int.leaf1_id }}.L{{ int.leaf2_id }}.1.{{ int.interface_id }}-intpolgrp"
    loop: "{{ interface.list }}"
    loop_control:
             loop_var: int
             label: "DELETE PORT SELECTOR NAME: vpc.L{{ int.leaf1_id }}.L{{ int.leaf2_id }}.1.{{ int.interface_id }}-intsel to INTERFACE PROFILE NAME: vpc.{{ int.dc }}-{{ int.env }}-L{{ int.leaf1_id }}.L{{ int.leaf2_id }}-intprof with POLICY GROUP NAME: vpc.L{{ int.leaf1_id }}.L{{ int.leaf2_id }}.1.{{ int.interface_id }}-intpolgrp"
             pause: "{{ delay_var }}"
    
  - name: Delete interface policy leaf policy group
    aci_interface_policy_leaf_policy_group:
      <<: *apic_login
      lag_type: node
      policy_group: "vpc.L{{ int.leaf1_id }}.L{{ int.leaf2_id }}.1.{{ int.interface_id }}-intpolgrp"
      aep: taxud-aaep
      cdp_policy: cdp.on-intpol
      lldp_policy: lldp.on-intpol
      link_level_policy: autonego-intpol
      mcp_policy: mcp.off-intpol 
      stp_interface_policy: bpdu.guard-intpol
      port_channel_policy: pc.lacp.active-intpol  
    loop: "{{ interface.list }}"
    loop_control:
             loop_var: int
             label: "DELETE INTERFACE POLICY GROUP NAME: vpc.L{{ int.leaf1_id }}.L{{ int.leaf2_id }}.1.{{ int.interface_id }}-intpolgrp"
             pause: "{{ delay_var }}"
             
#  - name: Add LACP override policy
#    aci_rest:
#      <<: *apic_login
#      path: /api/mo/uni.json
#      method: post
#      content:
#       {"infraAccBndlSubgrp":{"attributes":{"dn":"uni/infra/funcprof/accbundle-vpc.L{{ int.leaf1_id }}.L{{ int.leaf2_id }}.1.{{ int.interface_id }}-intpolgrp/accsubbndl-fast.lacp-overpolgrp","name":"fast.lacp-overpolgrp","rn":"accsubbndl-fast.lacp-overpolgrp"},"children":[{"infraRsLacpInterfacePol":{"attributes":{"tnLacpIfPolName":"pc.fast.lacp-intpol"},"children":[]}}]}}
#    loop: "{{ interface.list }}"
#    loop_control:
#             loop_var: int
#             label: "Adding LACP override policy to interface policy NAME: vpc.L{{ int.leaf1_id }}.L{{ int.leaf2_id }}.1.{{ int.interface_id }}-intpolgrp"
#             pause: "{{ delay_var }}"
             

      

      
